diff --git a/doc/src/sgml/maintenance.sgml b/doc/src/sgml/maintenance.sgml
index 08e6489afb8..611eceda0bc 100644
--- a/doc/src/sgml/maintenance.sgml
+++ b/doc/src/sgml/maintenance.sgml
@@ -59,7 +59,7 @@
    pleasant and productive experience with the system.
   </para>
 
- <sect1 id="routine-vacuuming">
+ <sect1 id="routine-vacuuming" xreflabel="Routine Vacuuming">
   <title>Routine Vacuuming</title>
 
   <indexterm zone="routine-vacuuming">
@@ -82,7 +82,7 @@
    to skim this material to help them understand and adjust autovacuuming.
   </para>
 
-  <sect2 id="vacuum-basics">
+  <sect2 id="vacuum-basics" xreflabel="Vacuuming Basics">
    <title>Vacuuming Basics</title>
 
    <para>
@@ -145,7 +145,7 @@
    </para>
   </sect2>
 
-  <sect2 id="vacuum-for-space-recovery">
+  <sect2 id="vacuum-for-space-recovery" xreflabel="Recovering Disk Space">
    <title>Recovering Disk Space</title>
 
    <indexterm zone="vacuum-for-space-recovery">
@@ -255,7 +255,7 @@
    </tip>
   </sect2>
 
-  <sect2 id="vacuum-for-statistics">
+  <sect2 id="vacuum-for-statistics" xreflabel="Updating Planner Statistics">
    <title>Updating Planner Statistics</title>
 
    <indexterm zone="vacuum-for-statistics">
@@ -371,7 +371,7 @@
 
   </sect2>
 
-  <sect2 id="vacuum-for-visibility-map">
+  <sect2 id="vacuum-for-visibility-map" xreflabel="Updating the Visibility Map">
    <title>Updating the Visibility Map</title>
 
    <para>
@@ -400,7 +400,7 @@
    </para>
   </sect2>
 
-  <sect2 id="vacuum-for-wraparound">
+  <sect2 id="vacuum-for-wraparound" xreflabel="Preventing Transaction ID Wraparound Failures">
    <title>Preventing Transaction ID Wraparound Failures</title>
 
    <indexterm zone="vacuum-for-wraparound">
@@ -752,7 +752,7 @@ HINT:  Execute a database-wide VACUUM in that database.
     </para>
    </note>
 
-   <sect3 id="vacuum-for-multixact-wraparound">
+   <sect3 id="vacuum-for-multixact-wraparound" xreflabel="Multixacts and Wraparound">
     <title>Multixacts and Wraparound</title>
 
     <indexterm>
@@ -855,7 +855,7 @@ HINT:  Execute a database-wide VACUUM in that database.
    </sect3>
   </sect2>
 
-  <sect2 id="autovacuum">
+  <sect2 id="autovacuum" xreflabel="The Autovacuum Daemon">
    <title>The Autovacuum Daemon</title>
 
    <indexterm>
@@ -1036,7 +1036,7 @@ analyze threshold = analyze base threshold + analyze scale factor * number of tu
  </sect1>
 
 
- <sect1 id="routine-reindex">
+ <sect1 id="routine-reindex" xreflabel="Routine Reindexing">
   <title>Routine Reindexing</title>
 
   <indexterm zone="routine-reindex">
@@ -1084,7 +1084,7 @@ analyze threshold = analyze base threshold + analyze scale factor * number of tu
  </sect1>
 
 
- <sect1 id="logfile-maintenance">
+ <sect1 id="logfile-maintenance" xreflabel="Log File Maintenance">
   <title>Log File Maintenance</title>
 
   <indexterm zone="logfile-maintenance">
diff --git a/doc/src/sgml/manage-ag.sgml b/doc/src/sgml/manage-ag.sgml
index fe4cb4410cd..96b43531e54 100644
--- a/doc/src/sgml/manage-ag.sgml
+++ b/doc/src/sgml/manage-ag.sgml
@@ -14,7 +14,7 @@
   them.
  </para>
 
- <sect1 id="manage-ag-overview">
+ <sect1 id="manage-ag-overview" xreflabel="Overview">
   <title>Overview</title>
 
   <indexterm zone="manage-ag-overview">
@@ -93,7 +93,7 @@ SELECT datname FROM pg_database;
   </note>
  </sect1>
 
- <sect1 id="manage-ag-createdb">
+ <sect1 id="manage-ag-createdb" xreflabel="Creating a Database">
   <title>Creating a Database</title>
 
   <indexterm><primary>CREATE DATABASE</primary></indexterm>
@@ -196,7 +196,7 @@ createdb -O <replaceable>rolename</replaceable> <replaceable>dbname</replaceable
   </para>
  </sect1>
 
- <sect1 id="manage-ag-templatedbs">
+ <sect1 id="manage-ag-templatedbs" xreflabel="Template Databases">
   <title>Template Databases</title>
 
   <para>
@@ -310,7 +310,7 @@ createdb -T template0 <replaceable>dbname</replaceable>
   </note>
  </sect1>
 
- <sect1 id="manage-ag-config">
+ <sect1 id="manage-ag-config" xreflabel="Database Configuration">
   <title>Database Configuration</title>
 
   <para>
@@ -341,7 +341,7 @@ ALTER DATABASE mydb SET geqo TO off;
   </para>
  </sect1>
 
- <sect1 id="manage-ag-dropdb">
+ <sect1 id="manage-ag-dropdb" xreflabel="Destroying a Database">
   <title>Destroying a Database</title>
 
   <para>
@@ -377,7 +377,7 @@ dropdb <replaceable class="parameter">dbname</replaceable>
   </para>
  </sect1>
 
- <sect1 id="manage-ag-tablespaces">
+ <sect1 id="manage-ag-tablespaces" xreflabel="Tablespaces">
   <title>Tablespaces</title>
 
   <indexterm zone="manage-ag-tablespaces">
diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index 817fd9f4ca7..bc8e9d9a8e0 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -33,7 +33,7 @@
    query.
   </para>
 
- <sect1 id="monitoring-ps">
+ <sect1 id="monitoring-ps" xreflabel="Standard Unix Tools">
   <title>Standard Unix Tools</title>
 
   <indexterm zone="monitoring-ps">
@@ -127,7 +127,7 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
   </tip>
  </sect1>
 
- <sect1 id="monitoring-stats">
+ <sect1 id="monitoring-stats" xreflabel="The Cumulative Statistics System">
   <title>The Cumulative Statistics System</title>
 
   <indexterm zone="monitoring-stats">
@@ -152,7 +152,7 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
    of the cumulative statistics system.
   </para>
 
- <sect2 id="monitoring-stats-setup">
+ <sect2 id="monitoring-stats-setup" xreflabel="Statistics Collection Configuration">
   <title>Statistics Collection Configuration</title>
 
   <para>
@@ -217,7 +217,7 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
 
  </sect2>
 
- <sect2 id="monitoring-stats-views">
+ <sect2 id="monitoring-stats-views" xreflabel="Viewing Statistics">
   <title>Viewing Statistics</title>
 
   <para>
@@ -703,7 +703,7 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-activity-view">
+ <sect2 id="monitoring-pg-stat-activity-view" xreflabel="pg_stat_activity">
   <title><structname>pg_stat_activity</structname></title>
 
   <indexterm>
@@ -1170,7 +1170,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
    </note>
  </sect2>
 
- <sect2 id="monitoring-pg-stat-replication-view">
+ <sect2 id="monitoring-pg-stat-replication-view" xreflabel="pg_stat_replication">
   <title><structname>pg_stat_replication</structname></title>
 
   <indexterm>
@@ -1511,7 +1511,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-replication-slots-view">
+ <sect2 id="monitoring-pg-stat-replication-slots-view" xreflabel="pg_stat_replication_slots">
   <title><structname>pg_stat_replication_slots</structname></title>
 
   <indexterm>
@@ -1695,7 +1695,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-wal-receiver-view">
+ <sect2 id="monitoring-pg-stat-wal-receiver-view" xreflabel="pg_stat_wal_receiver">
   <title><structname>pg_stat_wal_receiver</structname></title>
 
   <indexterm>
@@ -1875,7 +1875,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-recovery-prefetch">
+ <sect2 id="monitoring-pg-stat-recovery-prefetch" xreflabel="pg_stat_recovery_prefetch">
   <title><structname>pg_stat_recovery_prefetch</structname></title>
 
   <indexterm>
@@ -2021,7 +2021,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-subscription">
+ <sect2 id="monitoring-pg-stat-subscription" xreflabel="pg_stat_subscription">
   <title><structname>pg_stat_subscription</structname></title>
 
   <indexterm>
@@ -2158,7 +2158,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-subscription-stats">
+ <sect2 id="monitoring-pg-stat-subscription-stats" xreflabel="pg_stat_subscription_stats">
   <title><structname>pg_stat_subscription_stats</structname></title>
 
   <indexterm>
@@ -2343,7 +2343,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-ssl-view">
+ <sect2 id="monitoring-pg-stat-ssl-view" xreflabel="pg_stat_ssl">
   <title><structname>pg_stat_ssl</structname></title>
 
   <indexterm>
@@ -2464,7 +2464,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-gssapi-view">
+ <sect2 id="monitoring-pg-stat-gssapi-view" xreflabel="pg_stat_gssapi">
   <title><structname>pg_stat_gssapi</structname></title>
 
   <indexterm>
@@ -2548,7 +2548,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-archiver-view">
+ <sect2 id="monitoring-pg-stat-archiver-view" xreflabel="pg_stat_archiver">
   <title><structname>pg_stat_archiver</structname></title>
 
   <indexterm>
@@ -2651,7 +2651,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
   </para>
  </sect2>
 
- <sect2 id="monitoring-pg-stat-io-view">
+ <sect2 id="monitoring-pg-stat-io-view" xreflabel="pg_stat_io">
   <title><structname>pg_stat_io</structname></title>
 
   <indexterm>
@@ -3087,7 +3087,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-bgwriter-view">
+ <sect2 id="monitoring-pg-stat-bgwriter-view" xreflabel="pg_stat_bgwriter">
   <title><structname>pg_stat_bgwriter</structname></title>
 
   <indexterm>
@@ -3156,7 +3156,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-checkpointer-view">
+ <sect2 id="monitoring-pg-stat-checkpointer-view" xreflabel="pg_stat_checkpointer">
   <title><structname>pg_stat_checkpointer</structname></title>
 
   <indexterm>
@@ -3303,7 +3303,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
   </para>
  </sect2>
 
- <sect2 id="monitoring-pg-stat-wal-view">
+ <sect2 id="monitoring-pg-stat-wal-view" xreflabel="pg_stat_wal">
    <title><structname>pg_stat_wal</structname></title>
 
   <indexterm>
@@ -3389,7 +3389,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
 </sect2>
 
- <sect2 id="monitoring-pg-stat-database-view">
+ <sect2 id="monitoring-pg-stat-database-view" xreflabel="pg_stat_database">
   <title><structname>pg_stat_database</structname></title>
 
   <indexterm>
@@ -3732,7 +3732,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-database-conflicts-view">
+ <sect2 id="monitoring-pg-stat-database-conflicts-view" xreflabel="pg_stat_database_conflicts">
   <title><structname>pg_stat_database_conflicts</structname></title>
 
   <indexterm>
@@ -3846,7 +3846,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-all-tables-view">
+ <sect2 id="monitoring-pg-stat-all-tables-view" xreflabel="pg_stat_all_tables">
   <title><structname>pg_stat_all_tables</structname></title>
 
   <indexterm>
@@ -4188,7 +4188,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-all-indexes-view">
+ <sect2 id="monitoring-pg-stat-all-indexes-view" xreflabel="pg_stat_all_indexes">
   <title><structname>pg_stat_all_indexes</structname></title>
 
   <indexterm>
@@ -4378,7 +4378,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-statio-all-tables-view">
+ <sect2 id="monitoring-pg-statio-all-tables-view" xreflabel="pg_statio_all_tables">
   <title><structname>pg_statio_all_tables</structname></title>
 
   <indexterm>
@@ -4523,7 +4523,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-statio-all-indexes-view">
+ <sect2 id="monitoring-pg-statio-all-indexes-view" xreflabel="pg_statio_all_indexes">
   <title><structname>pg_statio_all_indexes</structname></title>
 
   <indexterm>
@@ -4632,7 +4632,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-statio-all-sequences-view">
+ <sect2 id="monitoring-pg-statio-all-sequences-view" xreflabel="pg_statio_all_sequences">
   <title><structname>pg_statio_all_sequences</structname></title>
 
   <indexterm>
@@ -4710,7 +4710,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-user-functions-view">
+ <sect2 id="monitoring-pg-stat-user-functions-view" xreflabel="pg_stat_user_functions">
   <title><structname>pg_stat_user_functions</structname></title>
 
   <indexterm>
@@ -4809,7 +4809,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-pg-stat-slru-view">
+ <sect2 id="monitoring-pg-stat-slru-view" xreflabel="pg_stat_slru">
   <title><structname>pg_stat_slru</structname></title>
 
   <indexterm>
@@ -4938,7 +4938,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
 
  </sect2>
 
- <sect2 id="monitoring-stats-functions">
+ <sect2 id="monitoring-stats-functions" xreflabel="Statistics Functions">
   <title>Statistics Functions</title>
 
   <para>
@@ -5552,7 +5552,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
  </sect2>
  </sect1>
 
- <sect1 id="monitoring-locks">
+ <sect1 id="monitoring-locks" xreflabel="Viewing Locks">
   <title>Viewing Locks</title>
 
   <indexterm zone="monitoring-locks">
@@ -5601,7 +5601,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </para>
  </sect1>
 
- <sect1 id="progress-reporting">
+ <sect1 id="progress-reporting" xreflabel="Progress Reporting">
   <title>Progress Reporting</title>
 
   <para>
@@ -5617,7 +5617,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
    This may be expanded in the future.
   </para>
 
- <sect2 id="analyze-progress-reporting">
+ <sect2 id="analyze-progress-reporting" xreflabel="ANALYZE Progress Reporting">
   <title>ANALYZE Progress Reporting</title>
 
   <indexterm>
@@ -5871,7 +5871,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </note>
  </sect2>
 
- <sect2 id="cluster-progress-reporting">
+ <sect2 id="cluster-progress-reporting" xreflabel="CLUSTER Progress Reporting">
   <title>CLUSTER Progress Reporting</title>
 
   <indexterm>
@@ -6093,7 +6093,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </table>
  </sect2>
 
- <sect2 id="copy-progress-reporting">
+ <sect2 id="copy-progress-reporting" xreflabel="COPY Progress Reporting">
   <title>COPY Progress Reporting</title>
 
   <indexterm>
@@ -6239,7 +6239,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </table>
  </sect2>
 
- <sect2 id="create-index-progress-reporting">
+ <sect2 id="create-index-progress-reporting" xreflabel="CREATE INDEX Progress Reporting">
   <title>CREATE INDEX Progress Reporting</title>
 
   <indexterm>
@@ -6543,7 +6543,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
 
  </sect2>
 
- <sect2 id="vacuum-progress-reporting">
+ <sect2 id="vacuum-progress-reporting" xreflabel="VACUUM Progress Reporting">
   <title>VACUUM Progress Reporting</title>
 
   <indexterm>
@@ -6895,7 +6895,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </table>
  </sect2>
 
- <sect2 id="basebackup-progress-reporting">
+ <sect2 id="basebackup-progress-reporting" xreflabel="Base Backup Progress Reporting">
   <title>Base Backup Progress Reporting</title>
 
   <indexterm>
@@ -7082,7 +7082,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
 
  </sect1>
 
- <sect1 id="dynamic-trace">
+ <sect1 id="dynamic-trace" xreflabel="Dynamic Tracing">
   <title>Dynamic Tracing</title>
 
  <indexterm zone="dynamic-trace">
@@ -7115,7 +7115,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
    the macros in <filename>src/include/utils/probes.h</filename>.
   </para>
 
-  <sect2 id="compiling-for-trace">
+  <sect2 id="compiling-for-trace" xreflabel="Compiling for Dynamic Tracing">
    <title>Compiling for Dynamic Tracing</title>
 
   <para>
@@ -7127,7 +7127,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </para>
   </sect2>
 
-  <sect2 id="trace-points">
+  <sect2 id="trace-points" xreflabel="Built-in Probes">
    <title>Built-in Probes</title>
 
   <para>
@@ -7624,7 +7624,7 @@ FROM pg_stat_get_backend_idset() AS backendid;
 
   </sect2>
 
-  <sect2 id="using-trace-points">
+  <sect2 id="using-trace-points" xreflabel="Using Probes">
    <title>Using Probes</title>
 
   <para>
@@ -7684,7 +7684,7 @@ Total time (ns)                        2312105013
   </para>
   </sect2>
 
-  <sect2 id="defining-trace-points">
+  <sect2 id="defining-trace-points" xreflabel="Defining New Probes">
    <title>Defining New Probes</title>
 
   <para>
@@ -7825,7 +7825,7 @@ if (TRACE_POSTGRESQL_TRANSACTION_START_ENABLED())
 
  </sect1>
 
- <sect1 id="diskusage">
+ <sect1 id="diskusage" xreflabel="Monitoring Disk Usage">
   <title>Monitoring Disk Usage</title>
 
   <para>
@@ -7833,7 +7833,7 @@ if (TRACE_POSTGRESQL_TRANSACTION_START_ENABLED())
    <productname>PostgreSQL</productname> database system.
   </para>
 
-  <sect2 id="disk-usage">
+  <sect2 id="disk-usage" xreflabel="Determining Disk Usage">
    <title>Determining Disk Usage</title>
 
    <indexterm zone="disk-usage">
@@ -7934,7 +7934,7 @@ ORDER BY relpages DESC;
    </para>
   </sect2>
 
-  <sect2 id="disk-full">
+  <sect2 id="disk-full" xreflabel="Disk Full Failure">
    <title>Disk Full Failure</title>
 
    <para>
diff --git a/doc/src/sgml/mvcc.sgml b/doc/src/sgml/mvcc.sgml
index 049ee75a4ba..e43dd7411ce 100644
--- a/doc/src/sgml/mvcc.sgml
+++ b/doc/src/sgml/mvcc.sgml
@@ -17,7 +17,7 @@
    in this chapter.
   </para>
 
-  <sect1 id="mvcc-intro">
+  <sect1 id="mvcc-intro" xreflabel="Introduction">
    <title>Introduction</title>
 
    <indexterm>
@@ -78,7 +78,7 @@
    </para>
   </sect1>
 
-  <sect1 id="transaction-iso">
+  <sect1 id="transaction-iso" xreflabel="Transaction Isolation">
    <title>Transaction Isolation</title>
 
    <indexterm>
@@ -302,7 +302,7 @@
      </para>
    </important>
 
-  <sect2 id="xact-read-committed">
+  <sect2 id="xact-read-committed" xreflabel="Read Committed Isolation Level">
    <title>Read Committed Isolation Level</title>
 
    <indexterm>
@@ -477,7 +477,7 @@ COMMIT;
    </para>
   </sect2>
 
-  <sect2 id="xact-repeatable-read">
+  <sect2 id="xact-repeatable-read" xreflabel="Repeatable Read Isolation Level">
    <title>Repeatable Read Isolation Level</title>
 
    <indexterm>
@@ -597,7 +597,7 @@ ERROR:  could not serialize access due to concurrent update
    </note>
   </sect2>
 
-  <sect2 id="xact-serializable">
+  <sect2 id="xact-serializable" xreflabel="Serializable Isolation Level">
    <title>Serializable Isolation Level</title>
 
    <indexterm>
@@ -847,7 +847,7 @@ ERROR:  could not serialize access due to read/write dependencies among transact
   </sect2>
  </sect1>
 
-  <sect1 id="explicit-locking">
+  <sect1 id="explicit-locking" xreflabel="Explicit Locking">
    <title>Explicit Locking</title>
 
    <indexterm>
@@ -876,7 +876,7 @@ ERROR:  could not serialize access due to read/write dependencies among transact
     manager subsystem, refer to <xref linkend="monitoring"/>.
    </para>
 
-  <sect2 id="locking-tables">
+  <sect2 id="locking-tables" xreflabel="Table-Level Locks">
    <title>Table-Level Locks</title>
 
    <indexterm zone="locking-tables">
@@ -1238,7 +1238,7 @@ ERROR:  could not serialize access due to read/write dependencies among transact
     </table>
    </sect2>
 
-   <sect2 id="locking-rows">
+   <sect2 id="locking-rows" xreflabel="Row-Level Locks">
     <title>Row-Level Locks</title>
 
     <para>
@@ -1413,7 +1413,7 @@ ERROR:  could not serialize access due to read/write dependencies among transact
     </table>
    </sect2>
 
-   <sect2 id="locking-pages">
+   <sect2 id="locking-pages" xreflabel="Page-Level Locks">
     <title>Page-Level Locks</title>
 
     <para>
@@ -1426,7 +1426,7 @@ ERROR:  could not serialize access due to read/write dependencies among transact
 
    </sect2>
 
-   <sect2 id="locking-deadlocks">
+   <sect2 id="locking-deadlocks" xreflabel="Deadlocks">
     <title>Deadlocks</title>
 
     <indexterm zone="locking-deadlocks">
@@ -1510,7 +1510,7 @@ UPDATE accounts SET balance = balance - 100.00 WHERE acctnum = 22222;
     </para>
    </sect2>
 
-   <sect2 id="advisory-locks">
+   <sect2 id="advisory-locks" xreflabel="Advisory Locks">
     <title>Advisory Locks</title>
 
     <indexterm zone="advisory-locks">
@@ -1613,7 +1613,7 @@ SELECT pg_advisory_lock(q.id) FROM
 
   </sect1>
 
-  <sect1 id="applevel-consistency">
+  <sect1 id="applevel-consistency" xreflabel="Data Consistency Checks at the Application Level">
    <title>Data Consistency Checks at the Application Level</title>
 
    <para>
@@ -1651,7 +1651,7 @@ SELECT pg_advisory_lock(q.id) FROM
     break the cycle.
    </para>
 
-   <sect2 id="serializable-consistency">
+   <sect2 id="serializable-consistency" xreflabel="Enforcing Consistency with Serializable Transactions">
     <title>Enforcing Consistency with Serializable Transactions</title>
 
     <para>
@@ -1691,7 +1691,7 @@ SELECT pg_advisory_lock(q.id) FROM
     </warning>
    </sect2>
 
-   <sect2 id="non-serializable-consistency">
+   <sect2 id="non-serializable-consistency" xreflabel="Enforcing Consistency with Explicit Blocking Locks">
     <title>Enforcing Consistency with Explicit Blocking Locks</title>
 
     <para>
@@ -1763,7 +1763,7 @@ SELECT pg_advisory_lock(q.id) FROM
    </sect2>
   </sect1>
 
-  <sect1 id="mvcc-serialization-failure-handling">
+  <sect1 id="mvcc-serialization-failure-handling" xreflabel="Serialization Failure Handling">
    <title>Serialization Failure Handling</title>
 
    <indexterm>
@@ -1829,7 +1829,7 @@ SELECT pg_advisory_lock(q.id) FROM
    </para>
   </sect1>
 
-  <sect1 id="mvcc-caveats">
+  <sect1 id="mvcc-caveats" xreflabel="Caveats">
    <title>Caveats</title>
 
    <para>
@@ -1871,7 +1871,7 @@ SELECT pg_advisory_lock(q.id) FROM
    </para>
   </sect1>
 
-  <sect1 id="locking-indexes">
+  <sect1 id="locking-indexes" xreflabel="Locking and Indexes">
    <title>Locking and Indexes</title>
 
    <indexterm zone="locking-indexes">
diff --git a/doc/src/sgml/nls.sgml b/doc/src/sgml/nls.sgml
index 0ad1b2c9c45..2a699f79f8f 100644
--- a/doc/src/sgml/nls.sgml
+++ b/doc/src/sgml/nls.sgml
@@ -3,7 +3,7 @@
 <chapter id="nls">
  <title>Native Language Support</title>
 
- <sect1 id="nls-translator">
+ <sect1 id="nls-translator" xreflabel="For the Translator">
   <title>For the Translator</title>
 
   <para>
@@ -17,7 +17,7 @@
    to do this.  This section explains how to help.
   </para>
 
-  <sect2 id="nls-translator-requirements">
+  <sect2 id="nls-translator-requirements" xreflabel="Requirements">
    <title>Requirements</title>
 
    <para>
@@ -50,7 +50,7 @@
    </para>
   </sect2>
 
-  <sect2 id="nls-translator-concepts">
+  <sect2 id="nls-translator-concepts" xreflabel="Concepts">
    <title>Concepts</title>
 
    <para>
@@ -130,7 +130,7 @@ msgstr "another translated"
    </para>
   </sect2>
 
-  <sect2 id="nls-translator-message-catalogs">
+  <sect2 id="nls-translator-message-catalogs" xreflabel="Creating and Maintaining Message Catalogs">
    <title>Creating and Maintaining Message Catalogs</title>
 
    <para>
@@ -199,7 +199,7 @@ make update-po
    </para>
   </sect2>
 
-  <sect2 id="nls-translator-editing-po">
+  <sect2 id="nls-translator-editing-po" xreflabel="Editing the PO Files">
    <title>Editing the PO Files</title>
 
    <para>
@@ -298,10 +298,10 @@ msgstr "Die Datei %2$s hat %1$u Zeichen."
  </sect1>
 
 
- <sect1 id="nls-programmer">
+ <sect1 id="nls-programmer" xreflabel="For the Programmer">
   <title>For the Programmer</title>
 
-  <sect2 id="nls-mechanics">
+  <sect2 id="nls-mechanics" xreflabel="Mechanics">
    <title>Mechanics</title>
 
   <para>
@@ -434,7 +434,7 @@ fprintf(stderr, gettext("panic level %d\n"), lvl);
   </para>
   </sect2>
 
-  <sect2 id="nls-guidelines">
+  <sect2 id="nls-guidelines" xreflabel="Message-Writing Guidelines">
    <title>Message-Writing Guidelines</title>
 
   <para>
diff --git a/doc/src/sgml/notation.sgml b/doc/src/sgml/notation.sgml
index c3798d5f1be..6ff8f58277a 100644
--- a/doc/src/sgml/notation.sgml
+++ b/doc/src/sgml/notation.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/notation.sgml -->
 
-<sect1 id="notation">
+<sect1 id="notation" xreflabel="Conventions">
  <title>Conventions</title>
 
  <para>
diff --git a/doc/src/sgml/oauth-validators.sgml b/doc/src/sgml/oauth-validators.sgml
index 704089dd7b3..22ce45ecf43 100644
--- a/doc/src/sgml/oauth-validators.sgml
+++ b/doc/src/sgml/oauth-validators.sgml
@@ -26,7 +26,7 @@
   </para>
  </warning>
 
- <sect1 id="oauth-validator-design">
+ <sect1 id="oauth-validator-design" xreflabel="Safely Designing a Validator Module">
   <title>Safely Designing a Validator Module</title>
   <warning>
    <para>
@@ -38,7 +38,7 @@
    </para>
   </warning>
 
-  <sect2 id="oauth-validator-design-responsibilities">
+  <sect2 id="oauth-validator-design-responsibilities" xreflabel="Validator Responsibilities">
    <title>Validator Responsibilities</title>
    <para>
     Although different modules may take very different approaches to token
@@ -164,7 +164,7 @@
    </variablelist>
   </sect2>
 
-  <sect2 id="oauth-validator-design-guidelines">
+  <sect2 id="oauth-validator-design-guidelines" xreflabel="General Coding Guidelines">
    <title>General Coding Guidelines</title>
    <para>
     Developers should keep the following in mind when implementing token
@@ -247,7 +247,7 @@
    </variablelist>
   </sect2>
 
-  <sect2 id="oauth-validator-design-usermap-delegation">
+  <sect2 id="oauth-validator-design-usermap-delegation" xreflabel="Authorizing Users (Usermap Delegation)">
    <title>Authorizing Users (Usermap Delegation)</title>
    <para>
     The standard deliverable of a validation module is the user identifier,
@@ -286,7 +286,7 @@
   </sect2>
  </sect1>
 
- <sect1 id="oauth-validator-init">
+ <sect1 id="oauth-validator-init" xreflabel="Initialization Functions">
   <title>Initialization Functions</title>
   <indexterm zone="oauth-validator-init">
    <primary>_PG_oauth_validator_module_init</primary>
@@ -322,7 +322,7 @@ typedef const OAuthValidatorCallbacks *(*OAuthValidatorModuleInit) (void);
   </para>
  </sect1>
 
- <sect1 id="oauth-validator-callbacks">
+ <sect1 id="oauth-validator-callbacks" xreflabel="OAuth Validator Callbacks">
   <title>OAuth Validator Callbacks</title>
   <para>
    OAuth validator modules implement their functionality by defining a set of
@@ -330,7 +330,7 @@ typedef const OAuthValidatorCallbacks *(*OAuthValidatorModuleInit) (void);
    authentication request from the user.
   </para>
 
-  <sect2 id="oauth-validator-callback-startup">
+  <sect2 id="oauth-validator-callback-startup" xreflabel="Startup Callback">
    <title>Startup Callback</title>
    <para>
     The <function>startup_cb</function> callback is executed directly after
@@ -345,7 +345,7 @@ typedef void (*ValidatorStartupCB) (ValidatorModuleState *state);
    </para>
   </sect2>
 
-  <sect2 id="oauth-validator-callback-validate">
+  <sect2 id="oauth-validator-callback-validate" xreflabel="Validate Callback">
    <title>Validate Callback</title>
    <para>
     The <function>validate_cb</function> callback is executed during the OAuth
@@ -400,7 +400,7 @@ typedef struct ValidatorModuleResult
    </para>
   </sect2>
 
-  <sect2 id="oauth-validator-callback-shutdown">
+  <sect2 id="oauth-validator-callback-shutdown" xreflabel="Shutdown Callback">
    <title>Shutdown Callback</title>
    <para>
     The <function>shutdown_cb</function> callback is executed when the backend
diff --git a/doc/src/sgml/pageinspect.sgml b/doc/src/sgml/pageinspect.sgml
index 3a113439e1d..fa78b52d8b2 100644
--- a/doc/src/sgml/pageinspect.sgml
+++ b/doc/src/sgml/pageinspect.sgml
@@ -13,7 +13,7 @@
   debugging purposes.  All of these functions may be used only by superusers.
  </para>
 
- <sect2 id="pageinspect-general-funcs">
+ <sect2 id="pageinspect-general-funcs" xreflabel="General Functions">
   <title>General Functions</title>
 
   <variablelist>
@@ -156,7 +156,7 @@ test=# SELECT fsm_page_contents(get_raw_page('pg_class', 'fsm', 0));
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-heap-funcs">
+ <sect2 id="pageinspect-heap-funcs" xreflabel="Heap Functions">
   <title>Heap Functions</title>
 
   <variablelist>
@@ -282,7 +282,7 @@ test=# SELECT t_ctid, raw_flags, combined_flags
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-b-tree-funcs">
+ <sect2 id="pageinspect-b-tree-funcs" xreflabel="B-Tree Functions">
   <title>B-Tree Functions</title>
 
   <variablelist>
@@ -521,7 +521,7 @@ test=# SELECT itemoffset, ctid, itemlen, nulls, vars, data, dead, htid, tids[0:2
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-brin-funcs">
+ <sect2 id="pageinspect-brin-funcs" xreflabel="BRIN Functions">
   <title>BRIN Functions</title>
 
   <variablelist>
@@ -631,7 +631,7 @@ test=# SELECT * FROM brin_page_items(get_raw_page('brinidx', 5),
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-gin-funcs">
+ <sect2 id="pageinspect-gin-funcs" xreflabel="GIN Functions">
   <title>GIN Functions</title>
 
   <variablelist>
@@ -721,7 +721,7 @@ test=# SELECT first_tid, nbytes, tids[0:5] AS some_tids
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-gist-funcs">
+ <sect2 id="pageinspect-gist-funcs" xreflabel="GiST Functions">
   <title>GiST Functions</title>
 
   <variablelist>
@@ -811,7 +811,7 @@ test=# SELECT * FROM gist_page_items_bytea(get_raw_page('test_gist_idx', 0));
   </variablelist>
  </sect2>
 
- <sect2 id="pageinspect-hash-funcs">
+ <sect2 id="pageinspect-hash-funcs" xreflabel="Hash Functions">
   <title>Hash Functions</title>
 
   <variablelist>
